Loading...
Searching...
No Matches
Halide::Internal::IRMatcher::NegateOp< A > Struct Template Reference

`#include <IRMatch.h>`

## Classes

struct | pattern_tag

## Public Member Functions

template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound, typename A2>
HALIDE_ALWAYS_INLINE bool | match (NegateOp< A2 > &&p, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const
template<typename A1 = A>
HALIDE_ALWAYS_INLINE void | make_folded_const (halide_scalar_value_t &val, halide_type_t &ty, MatcherState &state) const noexcept

## Public Attributes

A | a

## Static Public Attributes

static constexpr uint32_t | binds = bindings<A>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::Sub
static constexpr IRNodeType | max_node_type = IRNodeType::Sub
static constexpr bool | canonical = A::canonical
static constexpr bool | foldable = A::foldable

## Detailed Description

template<typename A>
struct Halide::Internal::IRMatcher::NegateOp< A >

Definition at line 1953 of file IRMatch.h.

## Member Function Documentation

## match() [1/2]

template<typename A>
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::NegateOp< A >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1965 of file IRMatch.h.

References Halide::Internal::Sub::_node_type, a, Halide::Internal::Sub::a, Halide::Internal::Sub::b, Halide::Expr::get(), HALIDE_ALWAYS_INLINE, Halide::Internal::is_const_zero(), and match().

Referenced by match(), and match().

## match() [2/2]

template<typename A>
template<uint32_t bound, typename A2>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::NegateOp< A >::match | ( | NegateOp< A2 > && | p,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1975 of file IRMatch.h.

References a, HALIDE_ALWAYS_INLINE, match(), and Halide::Internal::IRMatcher::unwrap().

## make()

template<typename A>

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::NegateOp< A >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint ) const

inline

Definition at line 1980 of file IRMatch.h.

References a, Halide::Internal::Sub::make(), Halide::Internal::make_zero(), and Halide::Expr::type().

## make_folded_const()

template<typename A>
template<typename A1 = A>

HALIDE_ALWAYS_INLINE void Halide::Internal::IRMatcher::NegateOp< A >::make_folded_const | ( | halide_scalar_value_t & | val,
|  | halide_type_t & | ty,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1989 of file IRMatch.h.

References a, HALIDE_ALWAYS_INLINE, halide_type_bfloat, halide_type_float, halide_type_int, halide_type_uint, and Halide::Internal::IRMatcher::MatcherState::signed_integer_overflow.

## Member Data Documentation

## a

template<typename A>

A Halide::Internal::IRMatcher::NegateOp< A >::a

Definition at line 1955 of file IRMatch.h.

Referenced by make(), make_folded_const(), match(), match(), and Halide::Internal::IRMatcher::operator<<().

## binds

template<typename A>

uint32_t Halide::Internal::IRMatcher::NegateOp< A >::binds = bindings<A>::mask

static constexpr

Definition at line 1957 of file IRMatch.h.

## min_node_type

template<typename A>

IRNodeType Halide::Internal::IRMatcher::NegateOp< A >::min_node_type = IRNodeType::Sub

static constexpr

Definition at line 1959 of file IRMatch.h.

## max_node_type

template<typename A>

IRNodeType Halide::Internal::IRMatcher::NegateOp< A >::max_node_type = IRNodeType::Sub

static constexpr

Definition at line 1960 of file IRMatch.h.

## canonical

template<typename A>

bool Halide::Internal::IRMatcher::NegateOp< A >::canonical = A::canonical

static constexpr

Definition at line 1962 of file IRMatch.h.

## foldable

template<typename A>

bool Halide::Internal::IRMatcher::NegateOp< A >::foldable = A::foldable

static constexpr

Definition at line 1986 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h